const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const workout_exercises = sequelize.define(
    'workout_exercises',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

sort_order: {
        type: DataTypes.INTEGER,
      
      

      },

sets: {
        type: DataTypes.INTEGER,
      
      

      },

reps: {
        type: DataTypes.INTEGER,
      
      

      },

rest_seconds: {
        type: DataTypes.INTEGER,
      
      

      },

beginner_modifications: {
        type: DataTypes.TEXT,
      
      

      },

advanced_progressions: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  workout_exercises.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity


















































































































//end loop



    db.workout_exercises.belongsTo(db.workouts, {
      as: 'workout',
      foreignKey: {
        name: 'workoutId',
      },
      constraints: false,
    });

    db.workout_exercises.belongsTo(db.exercises, {
      as: 'exercise',
      foreignKey: {
        name: 'exerciseId',
      },
      constraints: false,
    });




    db.workout_exercises.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.workout_exercises.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return workout_exercises;
};


